//
//  Guit Script Editor
//  Guit GUI Toolkit
//  Copyright © 2019/2020 Eric Lecolinet. All rights reserved.
//  http://www.telecom-paris.fr/~elc
//

#ifndef Guit_ScriptEditor_hpp
#define Guit_ScriptEditor_hpp
#include <guit.hpp>
using namespace guit;

class ScriptEditor : public GWindow {
public:
  ScriptEditor();
  void readFile(GString const& filename);
  void writeFile(GString const& filename);
  void build();

private:
  void showInspector();
  void showBuider();
  void reset();
  void inspectCB(GMouseEvent&);
  void inspectedCB(Gadget*);
  void inspectingCB(int);

  static constexpr auto Example = "script.guit";
  class GInspector& inspect;
  GBool changed;
  GText code, errors;
  GTextArea codearea{"#codearea"};
  gptr<GWindow> scriptwin;
  Gadget* selected_gadget{};
  GTextAttributes tokens;
  GTextAttr* clickedattr{};
  GPropList clickedprops, selection{"background:orange"};
};

#endif
